;###############################################################################
;
;	PIC LAMP
;
;		Assemble by pa-3.0.5s(b5e0048474cce2a1ba49a54faf9b1e86 */usr/local/bin/pa.exe)
;

;-------------------------------------------------------------------------------
;
;	إå
;
		include	my12f675.h
		.16f84				; PIC16F84()

;-------------------------------------------------------------------------------
;
;	ϥݡ
;
MYTRIS		equ	00101000b		; (0:, 1:())
COLOR_LED	equ	       0		; ֲLED L:ON
WHITE_LED	equ	      1			; LED L:ON
LED_DRIVER	equ	     2			; ɥLEDɥ饤 H:ON
SWING_SNS	equ	  5			; Х L:ON

;-------------------------------------------------------------------------------
;
;	EEPROM
;
		eeorg	0			; EEDATA

;-------------------------------------------------------------------------------
;
;	ꥻ
;
		org	20h			; ޥå

aTemp		ds	1			; A쥸
sTemp		ds	1			; STATUS쥸

swing		ds	1			; ɤ줿ץե饰
offcnt		ds	1			; 

waitCntS	ds	1			; Ԥѥ
waitCntM	ds	1
waitCntL	ds	1

;-------------------------------------------------------------------------------
;
;	ץॻ
;
		org	00h			; ꥻåȥ٥
		JP	start

;-------------------------------------------------------------------------------
;
;	߽
;
		org	04h			; ߥ٥
isrStart
		LD	(aTemp),A		; 쥸
		SWAP	(STATUS)>A
		RES	RP0, (STATUS)		; Х0
		LD	(sTemp),A
isrSwitch
		BIT	GPIF, (INTCON)		; ȯװGPIOѲ
		JP	Z, isrEnd

		INC	(swing)			; ɤ줿ץե饰ON
		RES	GPIF, (INTCON)		; ȯե饰ߤ()
isrEnd
		SWAP	(sTemp)>A		; 쥸
		LD	(STATUS),A
		SWAP	(aTemp)
		SWAP	(aTemp)>A
		RETI

;-------------------------------------------------------------------------------
;
;	å׽
;
start
		RES	RP0, (STATUS)		; Х0

		LD	A, 00000100b
		LD	(GPIO), A		; ݡȤ
		LD	A, 00000111b
		LD	(CMCON), A		; ѥ졼OFF

		SET	RP0, (STATUS)		; Х1

		CLR	(ANSEL)			; ǥ I/O
		LD	A, MYTRIS		; :11111111b
		LD	(TRISIO), A		; ݡ
timerSet
		CLR	(WDT)			; åɥåޡץꥹ饯ꥢ

		LD	A, 11111111b		; :11111111b
		LD	(OPTION), A		; 7:GPIOץ륢å(0:Ѥ)
						; 6:GP2ߥݡѲ(0:Ω)
						; 5:TMR0åӥå(0:)
						; 4:GP2ѲTMR0ûߥ(0:Ω)
						; 3:ץꥹƥӥå(0:TMR0)
						; 2~0ץꥹ졼ӥå(111:1/256)

		LD	A, 00100000b		; ߤ򸡽ФGPIOԥ
		LD	(IOC), A

		RES	RP0, (STATUS)		; Х0

		CLR	(TMR0)			; ޥꥢ
intStart
		LD	A, 10001000b		; :00000000b
		LD	(INTCON), A		; 7:Хߥ֥͡
						; 6:ֳߥ֥͡
						; 5:TMR0Сեߥ֥͡
						; 4:GP2ݡѲߥ֥͡
						; 3:ݡѲߥ֥͡

;--------------------------------------------------------------------------------
;
;	ᥤ
;
LOOP
		CLR	(swing)

		LD	A, 00000100b		; ֲ &  LED ON
		LD	(GPIO), A

		LD	A, 100			; 10äξ硢100ꤹȡ
		CALL	WAITnx01sm25us		; 2Ԥ 100 x 100ms - 25us 񤹤

		LD	A, (swing)		; ɤƤ顢LEDĹ
		JP	NZ, LOOP

		SET	WHITE_LED, (GPIO)	; LED OFF

		LD	A, 200
		LD	(offcnt), A
LOOP1
		LD	A, 200			; 0.1äξ硢200ꤹȡ
		CALL	WAITnx500m35us		; 2Ԥ 200 x 500 - 35 = 99.965ms 񤹤

		LD	A, (swing)		; ɤƤ顢LEDĹ
		JP	NZ, LOOP

		DEC	(offcnt)
		JP	NZ, LOOP1

		LD	A, 00000011b		; ֲ &  LED OFF
		LD	(GPIO), A

		HALT				; sleep
		NOP

		JP	LOOP

;--------------------------------------------------------------------------------
;
;	Ԥ()
;
;		LD	A, 10			; 10ꤹȡ
;		CALL	WAITnx3p5us		; 2Ԥ 10 x 3 + 5 = 35us 
;
WAITnx3p5us
		LD	(waitCntS), A
WAITnx3p5us1
		DJNZ	(waitCntS), WAITnx3p5us1
		RET

;--------------------------------------------------------------------------------
;
;	Ԥ()
;
;		LD	A, 200			; 0.1äξ硢200ꤹȡ
;		CALL	WAITnx500m35us		; 2Ԥ 200 x 500 - 35 = 99.965ms 񤹤
;
WAITnx500m35us
		LD	(waitCntM), A
		JP	WAITnx500m35us2
WAITnx500m35us1	NOP
		LD	A, 12			;  12 x 3 + 5 =  41us
		CALL	WAITnx3p5us		;		λԤ
WAITnx500m35us2	LD	A, 150			; 150 x 3 + 5 = 455us
		CALL	WAITnx3p5us		;		λԤ
		DJNZ	(waitCntM), WAITnx500m35us1
		RET

;--------------------------------------------------------------------------------
;
;	Ԥ()
;
;		LD	A, 10			; 1äξ硢10ꤹȡ
;		CALL	WAITnx01sm25us		; 2Ԥ 10 x 100ms - 25us 񤹤
;
WAITnx01sm25us
		LD	(waitCntL), A
		JP	WAITnx01sm25us2
WAITnx01sm25us1	LD	A, 9
		CALL	WAITnx3p5us
WAITnx01sm25us2	LD	A, 200
		CALL	WAITnx500m35us
		DJNZ	(waitCntL), WAITnx01sm25us1
		RET

